using Benday.Presidents.Common;
using Benday.Presidents.Core.Models;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.ModelConfiguration.Conventions;
using System.Linq;

namespace Benday.Presidents.Core.DataAccess
{
    public class PresidentsDbContext : DbContext, IPresidentsDbContext
    {
        
        public PresidentsDbContext() : base("name=(default)")
        {
            
        }

        protected PresidentsDbContext(string connectionString) : 
            base(connectionString)
        {

        }

        public IDbSet<Person> Persons { get; set; }
        public IDbSet<PersonFact> PersonFacts { get; set; }
        public IDbSet<Relationship> Relationships { get; set; }


        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Conventions.Remove<PluralizingTableNameConvention>();

            modelBuilder.Entity<Relationship>().HasRequired(rel => rel.FromPerson).WithMany(p => p.Relationships).Map(m => m.MapKey("FromPersonId"));
        }
    }
}
